<?php
namespace dsmirror;

/**
 *
 * @author Tecknolab
 *        
 */
interface IReplicationService
{
    public function getDSList () /*: iterable*/; //DSConfig iterable
    public function getDSListReverse () /*: iterable*/; //DSConfig iterable
    public function generateCandidateReverseDSConfigScript ($targetDB) /*: string*/;
    public function registerCandidateReverseDSConfig ($metadata)/*: iterable*/; //DSConfig iterable
    public function registerDSReplica ($dsConfigId, $dsReplicaOptions) /*: DSReplica*/;
    public function generateTargetDSScript ($dsReplicaId) /*: string*/;
    public function startSyncDS ($dsReplicaId) /*: ReplicationMap*/;
    public function getReplicationDirtySegments ($jobId, $segmentHashArray) /*: iterable*/; //SegmentHashDescriptor iterable
    public function getSegmentReplicationDelta ($jobId, $segmentContentHashResult) /*: ReplicationDelta*/;
    public function confirmReplicationDelta ($jobId, $replicationDeltaResult);
    public function abortReplicationDelta ($jobId, $replicationError);
    public function finishSyncDS($jobId);
    public function deleteReplica($dsReplicaId);
    public function getReplicationContext($jobId); /* ReplicationContext */
}

