<?php
/**
 * Author: Tecknolab
 * Author URI: https://tecknolab.com/
 * License: GPLv2
 **/
require_once 'ReplicationManager.php';
require_once 'Model.php';

const DSMIRROR_VERSION='1.01.04';
const DSMIRROR_URL='https://dsmirror.tecknolab.com?utm_source=pluginwp&utm_medium=1.01.04&utm_campaign=std';
const DSMIRROR_LOGO_URL='https://dsmirror.tecknolab.com/logo-transparent';
const DSMIRROR_FREE_LICENSE_URL='https://dsmirror.tecknolab.com/free?utm_source=pluginwp&utm_medium=1.01.04&utm_campaign=std';
const DSMIRROR_BUY_URL='https://dsmirror.tecknolab.com/buy?utm_source=pluginwp&utm_medium=1.01.04&utm_campaign=std';
const DSMIRROR_INSTALL_URL='https://dsmirror.tecknolab.com/install?utm_source=pluginwp&utm_medium=1.01.04&utm_campaign=std';
const DSMIRROR_ENDPOINT='https://app.dsmirror.tecknolab.com/dsmirror';
const DEFAULT_TIMEOUT=29;
const MAX_PROPERTIES_INTERVAL=86400;

const CONFIG_PARAM_REGISTRATION='dsmirror.registration';
const REGISTRATION_ACTIVE='ACTIVE';
const REGISTRATION_STATUS='STATUS';
const REGISTRATION_APPID='APPID';
const REGISTRATION_SECRET='SECRET';
const REGISTRATION_REVERSE='REVERSE';
const REGISTRATION_PROPERTIES='PROPERTIES';
const REGISTRATION_PROPERTIES_TS='PROPERTIES_TS';

const CONFIG_PARAM_REPLICAS='dsmirror.replicas';
const REPLICAS_SCHEDULING = 'SCHEDULING';
const REPLICAS_LIST = 'LIST';
const REPLICAS_CREATE_TABLE = 'CREATE_TABLE';

const CONFIG_PARAM_EXECUTION='dsmirror.execution';
const EXECUTION_STATUS='STATUS';
const EXECUTION_STATS='STATS';
const EXECUTION_START_TS="START";
const EXECUTION_LAST_TS='LAST';
const EXECUTION_END_TS="END";
const EXECUTION_INDEX='INDEX';
const EXECUTION_REPLICAS='REPLICAS';

const EXEC_OK_STATUS="E";
const EXEC_ERROR_STATUS="F";
const EXEC_NEVER_STATUS="N";
const EXEC_RUNNING_STATUS="R";
const EXEC_PAUSE_STATUS="P";
const EXEC_STR_ARRAY = array(EXEC_NEVER_STATUS=>"Never run.", EXEC_OK_STATUS=>"Executed OK.", EXEC_ERROR_STATUS=>"Failed execution.", EXEC_RUNNING_STATUS=>"Running.", EXEC_PAUSE_STATUS=>"Paused. To be restarted in few secs.");
const EXEC_STATUS_COLOR_ARRAY = array(EXEC_NEVER_STATUS=>"LemonChiffon", EXEC_OK_STATUS=>"PaleGreen", EXEC_ERROR_STATUS=>"Tomato", EXEC_RUNNING_STATUS=>"SkyBlue", EXEC_PAUSE_STATUS=>"PapayaWhip");

const SCHED_NEVER="N";
const SCHED_5MINUTES="5";
const SCHED_QUARTERLY="Q";
const SCHED_HOURLY="H";
const SCHED_DAILY="D";
const SCHED_SECONDS_ARRAY = array(SCHED_NEVER=>0, SCHED_5MINUTES=>300, SCHED_QUARTERLY=>900, SCHED_HOURLY=>3600, SCHED_DAILY=>86400);
const SCHED_DESC_ARRAY = array(SCHED_NEVER=>'Never. Disabled', SCHED_5MINUTES=>'5 Minutes', SCHED_QUARTERLY=>'15 Minutes', SCHED_HOURLY=>'1 hour', SCHED_DAILY=>'Daily');

